<?php
/******************************************************************************
*  Xaseco2 plugin (TM2)                                                       *
*  Description : Apply handicaps and display an adjusted end screen results   *
*  Configuration: None                                                        *
*                                                                             *
*  Author: Mikey (mysql code thanks to TheM)                                  *
*  Version: 0.40                                                              *  
******************************************************************************/    
                                                      
Aseco::registerEvent("onStartup", "init_handicap");
Aseco::registerEvent("onBeginMap", "begin_handicap");
Aseco::registerEvent("onPlayerConnect", "join_handicap");
Aseco::registerEvent('onPlayerDisconnect', 'left_handicap');
Aseco::registerEvent("onEverySecond", "count_handicap");
Aseco::registerEvent("onEndMap", "end_handicap");
Aseco::addChatCommand("handicap", "handicap on/off");


function init_handicap($aseco, $challenge) {
  global $aseco, $hcap_tick, $hcap_data, $hcap_plyr ;
  $hcap_tick = 99 ;
  $hcap_plyr = array();
  $hcap_data['Show'] = 0 ;
  $hcap_data['Left'] = array(); 
  $hcap_data['Adjust'] = 1.00 ;
  
  $fields = array();
	$result = mysql_query('SHOW COLUMNS FROM `players_extra`;');
	if($result) {
		while($row = mysql_fetch_row($result)) {
			$fields[] = $row[0];
		}
		mysql_free_result($result);
	}
  if(!in_array('Handicap', $fields)) {
		mysql_query("ALTER TABLE `players_extra` ADD `Handicap` VARCHAR( 255 ) NOT NULL DEFAULT '0,0,0,0,0,0,0,0,0,0,0' COMMENT 'Added by plugin.handicap.php'");
	}
}


function chat_handicap($aseco, $command) {
  global $aseco, $hcap_data, $hcap_plyr, $hcap_tick ;
  $player = $command['author'];
  $login = $player->login;
  $average = (array_sum($hcap_plyr[$login])/10);
  $handicap = round((3-$average)*$hcap_data['Adjust'],3);
  if ($hcap_data['Show']==0) $msg = '$i$ff0Your current handicap $fff'.$handicap.'%,$ff0 (Handicap Disabled)' ;
  else $msg = '$i$ff0Your current handicap '.$handicap.'%,$ff0  (Handicap Enabled)' ;
  $arglist = explode(' ', $command['params'], 2);   // split params into arrays & insure optional parameters exist
  if (!isset($arglist[1])) $arglist[1] = '';
  $command['params'] = explode(' ', preg_replace('/ +/', ' ', $command['params']));
  if (!isset($command['params'][1])) $command['params'][1] = '';
// insert non admin commands here if needed 
  if ($aseco->isMasterAdmin($player) || $aseco->isAdmin($player)) {   // admin
    $msg = '$i$ff0Usage: /handicap on | off , Your current handicap $fff'.$handicap.'%' ;
    if ($command['params'][0] == 'off' || $command['params'][0] == 'disable') {
      $hcap_data['Show'] = 0 ;
      $msg = '$f80Handicap $fffDisabled' ;
      $xml = "<manialink posx='1.0' posy='0.35' id='0'> 
        </manialink>
          <custom_ui>
            <challenge_info visible='false'/>                              
            <scoretable visible='true'/>
          </custom_ui>";
      $aseco->client->query("SendDisplayManialinkPage", $xml, 0, false);   // Enable normal end/tab screen results
    } 
    if ($command['params'][0] == 'on' || $command['params'][0] == 'enable') {
      $hcap_data['Show'] = 1 ;
      $msg = '$f80Handicap racing $fffEnabled' ;
    }  
  }
  $aseco->client->query('ChatSendServerMessageToLogin', $msg, $login);   
}


function begin_handicap($aseco, $map) {                    // new map
  global $aseco, $hcap_data, $hcap_plyr ;
  $hcap_data['Mode'] = $aseco->server->gameinfo->mode;
  $aseco->client->query('GetChatTime'); 
  $chattime = $aseco->client->getResponse('CurrentValue');
  $hcap_data['End'] = $chattime['CurrentValue'];
  $xml = "<manialink posx='1.0' posy='0.35' id='0'> 
    </manialink>
      <custom_ui>
        <challenge_info visible='false'/>                              
          <scoretable visible='true'/>
        </custom_ui>";
  $aseco->client->query("SendDisplayManialinkPage", $xml, 0, false);   // Enable normal end screen results for tab ingame
  $xml = '<manialink id="0815460000129">
        </manialink>';
  $aseco->client->addCall('SendDisplayManialinkPage', array($xml, -1, false));  // Kill end screen
}


function join_handicap($aseco, $player) {                  // player connects
  global $aseco, $hcap_plyr ;
  $login = $player->login ;
  $msg = '$f80Handicap racing $fffEnabled' ; 
	$dbinfo = mysql_fetch_object(mysql_query("SELECT `Id` FROM `players` WHERE `Login` = '".$player->login."'"));
	if(!isset($hcap_plyr[$login])) {
		$sql = "SELECT `Handicap` FROM `players_extra` WHERE `PlayerId` = '".$dbinfo->Id."'";
		$result = mysql_fetch_object(mysql_query($sql));
		if ($result->Handicap=='0,0,0,0,0,0,0,0,0,0,0') {
		  $msg = '$f80Handicap racing $fffEnabled$f80, several results are needed before your handicap is accurate.' ;
      $hcap_plyr[$login]=array(0,3,4,4,5,5,5,6,6,7,5);
      print('<PlayerNew> '.$login.' sql read AS ZERO ? ='.$result->Handicap." \n\r")  ;
      }
    else $hcap_plyr[$login] = explode(',', $result->Handicap);              // * expects paramter 2 to be a string
    $aseco->client->query('ChatSendServerMessageToLogin', $msg, $login); 
  }
}  

function left_handicap($aseco, $player) {                  // player disconnects
  global $aseco, $hcap_data, $hcap_plyr ;
  $login = $player->login ;
  array_push($hcap_data['Left'],$login);
}


function end_handicap($aseco, $command) {                // End screen podium
  global $aseco, $hcap_data, $hcap_tick, $hcap_score, $hcap_plyr ;
  if ($hcap_data['Mode']<>2) return ;   // not TimeAttack
  $results = $command[0];
  $aseco->client->query('GetCurrentRanking',255,0);
  $rankings = $aseco->client->getResponse();
  if (!isset($results[3])) return;                      // too few players
  $hcap_tick = -1 ;
  $plyr_score = array();
  $hcap_score = array();
  $best_time = array();

  foreach($results as $dat) {                           // get all times and score
    if ($dat['BestTime']>0) $best_time[$dat['Login']] = $dat['BestTime'];
  }
  sort($best_time, SORT_NUMERIC);                       // sort to find winning time in TA 
  if(isset($best_time[0])) $win_time = $best_time[0];

  foreach($results as $dat) {                           // calc on all times and score
    if(isset($aseco->server->players->player_list[$dat['Login']])) {
      $ladderrank= $aseco->server->players->player_list[$dat['Login']]->ladderrank;
      $laddertotal= round($aseco->server->players->player_list[$dat['Login']]->ladderscore,0);   
    } else {
      $ladderrank= '';
      $laddertotal= ''; 
    }
    if ($dat['BestTime']>0) {
      $plyr_score[$dat['Login']] = $dat['BestTime'] ;
      $average = (array_sum($hcap_plyr[$dat['Login']])/10);
      $handicap = round(((3-$average)/100)*$dat['BestTime']*$hcap_data['Adjust']);
//      $hcap_new = round((1-($win_time/$dat['BestTime']))*100,2);
      $hcap_new = round((($dat['BestTime']/$win_time)-1)*100,2);
      if ($hcap_new >40) $hcap_new=$average+1;  
      if ($hcap_new >20) $hcap_new=20;
      if ($hcap_new >10 && $average<5) $hcap_new=($average*2)+1; 
   
    } else {
      $plyr_score[$dat['Login']] = 999999 ;
      $handicap = 0 ; // '' ;
      $average =1 ;
      $hcap_new = array_sum($hcap_plyr[$dat['Login']])/10;

    }
    $hcap_new=round($hcap_new,3);
    // array order [0]handicaped score, [1]nick, [2]login, [3]real score, [4]handicap penalty, [5] Rank ,[6] LadderRank, [7] LP won [8] LP Total
    $hcap_score[$dat['Rank']] = array(($plyr_score[$dat['Login']]+$handicap),$dat['NickName'],$dat['Login'],$plyr_score[$dat['Login']],$handicap,$dat['Rank'],$ladderrank,$dat['LadderScore'],$laddertotal);

    $loop = 10 ;
    while ($loop>1) {
      $hcap_plyr[$dat['Login']][$loop]=$hcap_plyr[$dat['Login']][$loop-1];
      $loop -= 1;
    }
    $hcap_plyr[$dat['Login']][1]=$hcap_new;
    
  //   *** INSERT database write here , data to db = $hcap_plyr[$dat['Login']] 
		$todb = implode(',', $hcap_plyr[$dat['Login']]);
		$dbinfo = mysql_fetch_object(mysql_query("SELECT `Id` FROM `players` WHERE `Login` = '".$dat['Login']."'"));
		$sql = "UPDATE `players_extra` SET `Handicap` = '".$todb."' WHERE `PlayerId` = '".$dbinfo->Id."'";   
		mysql_query($sql); 
  }

  foreach($hcap_data['Left'] as $dat)  {
    unset($hcap_plyr[$dat]) ;
  }
  $hcap_data['Left'] = array();
  sort($hcap_score, SORT_REGULAR);   // sort to find winning time in TA    // stored using rank :) ?
}


function count_handicap($aseco, $command)  {
  global $aseco, $hcap_tick, $hcap_data, $hcap_score ;
  $hcap_tick += 1 ;

  if ($hcap_tick == 2) {
    if ($hcap_data['Show']<>1) return ;
    if ($hcap_data['Mode']<>2) return ;   // not TimeAttack
  
    $xml = "<manialink posx='1.0' posy='0.35' id='0'> 
      </manialink>
        <custom_ui>
          <challenge_info visible='false'/>                              
          <scoretable visible='false'/>
        </custom_ui>";
    $aseco->client->query("SendDisplayManialinkPage", $xml, 0, false);   // disable normal end screen results
    $numb=count($hcap_score);

    $xpos= -32 ;
    $ypos= 17.5 ;
    $rank = 0 ;
    $split= 12 ;
    $yadj= 3.4 ;
    
    if ($numb>24) {     //32
      $split= 16 ;
      $yadj= 2.6 ;
      }
    if ($numb<17) {     //16
      $split= 8 ;
      $yadj= 5.1 ;
      }  
    
    $xml = '<manialink id="0815460000129">
    <format style="TextRaceChat" textsize="1" />
      <frame posn="0 2 1">
        <quad posn="0 0 0" sizen="66 48"  halign="center" valign="center" style="BgsPlayerCard" substyle="BgCardSystem"  />
        <quad posn="0 22.3 1" sizen="65.5 2.7"  halign="center" valign="center" style="BgsPlayerCard" substyle="BgRacePlayerName"  />
        <label posn="0 22.5 2" sizen="65 2" halign="center" valign="center" text="$i$o$s$0f0Handicap Results" action="27008504"/>
      <format style="TextRaceStaticSmall" textsize="1" />
        <quad posn="0 20.2 1" sizen="65.5 1.8"  halign="center" valign="center" style="BgsPlayerCard" substyle="BgRacePlayerName"  />
        <label posn="-32 20.3 1" sizen="65 2" halign="left" valign="center" text="$000#.   Player" action="27008504"/>
        <label posn="-16.2 20.3 1" sizen="65 2" halign="left" valign="center" text="$000Time         Handicap      Result" action="27008504"/>
        <label posn="1.5 20.3 1" sizen="65 2" halign="left" valign="center" text="$000#.   Player" action="27008504"/>
        <label posn="16.8 20.3 1" sizen="65 2" halign="left" valign="center" text="$000Time         Handicap     Result" action="27008504"/>
      <format style="TextRaceChat" textsize="1" /> ';
      
    while ($rank<$numb) {
      if (isset($hcap_score[$rank])) {
        $prefix[0]='$z$s$ff0'; // handicapped time
        $prefix[3]='$z$s$fff'; // real time
        $prefix[4]='$z$s$aaa'; // handicap applied
        $prefix[5]='$z$s$ccc'; // real rank
        $prefix[7]='$z$972+'; // Ladder Points  
        if ($hcap_score[$rank][4]>0) $hcap_score[$rank][4] = '+'.sprintf("%05.3f",($hcap_score[$rank][4]/1000));
        else $hcap_score[$rank][4] = ''.sprintf("%05.3f",($hcap_score[$rank][4]/1000));
        if ($hcap_score[$rank][3]==999999){                                                   // no time set
          $hcap_score[$rank][0]=-1;
          $hcap_score[$rank][3]=-1;
          $hcap_score[$rank][4]='-';
          $prefix[0]='$z$s$777'; // handicapped time
          $prefix[3]='$z$s$777'; // real time
          $prefix[4]='$z$s$777'; // handicap applied
          $prefix[5]='$z$s$777'; // real rank  
                  
        }
        // array order [0]handicaped score, [1]nick, [2]login, [3]real score, [4]handicap penalty   , [5] rank , [6] LadderRank, [7] LP won [8] LP Total
        $xml .= '<label posn="'.$xpos.' '.$ypos.' 1" sizen="12 3" halign="left" valign="center" text="$z$s$fff'.($rank+1).'.  '.$hcap_score[$rank][1].'" action="27008504"/> 
                <label posn="'.($xpos+13.9).' '.$ypos.' 1" sizen="1.7 3" halign="center" valign="center" text="'.$prefix[5].'('.$hcap_score[$rank][5].')" action="27008504"/>
                <label posn="'.($xpos+20.2).' '.$ypos.' 1" sizen="6 3" halign="right" valign="center" text="'.$prefix[3].formatTime($hcap_score[$rank][3]).'" action="27008504"/>
                <label posn="'.($xpos+25.0).' '.$ypos.' 1" sizen="5 3" halign="right" valign="center" text="'.$prefix[4].$prefix[4].$hcap_score[$rank][4].'" action="27008504"/>
                <label posn="'.($xpos+31.3).' '.$ypos.' 1" sizen="6 3" halign="right" valign="center" text="'.$prefix[0].formatTime($hcap_score[$rank][0]).'" action="27008504"/> ';
        if ($numb<25){
//                 <label posn="'.($xpos+19.8).' '.($ypos-1.6).' 1" sizen="6 3" halign="right" valign="center" text="$bb4'.$prefix[7].sprintf("%04.2f",$hcap_score[$rank][7]).' LP" action="27008504"/>
        $xml .= '<format style="TextRaceStaticSmall" textsize="1" />
                <label posn="'.($xpos+2.4).' '.($ypos-1.6).' 1" sizen="13 3" halign="left" valign="center" text="$777'.$hcap_score[$rank][6].'" action="27008504"/>
                <label posn="'.($xpos+20.0).' '.($ypos-1.6).' 1" sizen="6 3" halign="right" valign="center" text="$777'.$hcap_score[$rank][8].' LP" action="27008504"/>
                <format style="TextRaceChat" textsize="1" /> ';
        }          
      }
      $ypos = $ypos-$yadj ;   
      $rank += 1 ;
      if ($rank==$split) {
        $xpos=1;
        $ypos=17.5; 
      }
    }  
    $xml .= '</frame>
            </manialink>';
  $aseco->client->addCall('SendDisplayManialinkPage', array($xml, 20000, false));

    }
  }
?>
